DECLARE SUB PlayAdlib (comand$, chann%, ins%())
DECLARE SUB WriteReg (reg%, value%)
DEFINT A-Z
DECLARE FUNCTION Dire (direcao$)
DECLARE FUNCTION Ret (atual, limite)
DECLARE SUB MilliDelay (msecs)
DECLARE SUB Font (Text$, xPos%, yPos%, TextColor%)
DECLARE SUB LoadGFX ()
DECLARE SUB GetKey ()
DECLARE SUB DrawAll ()
DECLARE SUB MoveM ()
DECLARE SUB MoveFire ()
DECLARE SUB KillMonster (number)
DECLARE SUB PlayFX (fxname$)
DECLARE SUB Aply ()
DECLARE SUB DrawMap (xmin, ymin, xmax, ymax)

  'Types
   TYPE MonsterType
      x     AS INTEGER
      y     AS INTEGER
      move  AS INTEGER
      dir   AS INTEGER
      id    AS INTEGER
      alive AS INTEGER
      flags AS INTEGER
   END TYPE
   TYPE PlayerType
      x    AS INTEGER
      y    AS INTEGER
      fire AS INTEGER
      heal AS INTEGER
      ykey AS INTEGER
      bkey AS INTEGER
      rkey AS INTEGER
   END TYPE
   TYPE FireType
      x     AS INTEGER
      y     AS INTEGER
      pow   AS INTEGER
      ready AS INTEGER
      dir   AS INTEGER
   END TYPE
   TYPE KeyType
      y AS INTEGER
      r AS INTEGER
      b AS INTEGER
   END TYPE


'DIMs
  'MAP
DIM SHARED map(1 TO 32, 1 TO 20) AS STRING * 1
  'GFX
DIM SHARED wall(50), grnd(50), man(50), rk(50), yk(50), bk(50), door(50)
DIM SHARED rl(50), yl(50), bl(50), Monster(50, 1), fire(50, 1 TO 4)
  'TYPE
DIM SHARED you AS PlayerType, monsters, f(1 TO 4) AS FireType
DIM SHARED keys(1) AS KeyType
  'ALL
DIM SHARED mf, MoveTime
DIM SHARED temp

    BaseAdd% = &H220
    RegAdd% = BaseAdd% + 8
    DataAdd% = BaseAdd% + 9

    Piano(1) = &H1
    Piano(2) = &H1
    Piano(3) = &H1F
    Piano(4) = &H0
    Piano(5) = &HE4
    Piano(6) = &HE4
    Piano(7) = &H9D
    Piano(8) = &H9D

mf = 1          'MaxFire
FOR i = 1 TO 4: f(i).ready = 1: f(i).pow = 1: NEXT i

SCREEN 7, 0, 1, 0

      LoadGFX
      lev = 1
      you.heal = 10
      you.fire = 50

lev = 1

OPEN "doomed." + LTRIM$(STR$(lev)) FOR INPUT AS #1
'Reading wall texture . . .
  FOR i = 0 TO 49
    INPUT #1, wall(i)
  NEXT i
              
               LINE INPUT #1, a$
               monsters = VAL(a$)
               DIM SHARED m(0 TO monsters) AS MonsterType
                  FOR i = 1 TO monsters: INPUT #1, a$
                  m(i).dir = Dire(LEFT$(a$, 1))
                  m(i).move = VAL(RIGHT$(a$, 1)): NEXT i
  
   FOR ii = 1 TO 20
      LINE INPUT #1, a$
   FOR i = 1 TO 32
      map(i, ii) = MID$(a$, i, 1)
      IF map(i, ii) = "S" THEN map(i, ii) = " ": you.x = i: you.y = ii
      IF map(i, ii) = "0" THEN map(i, ii) = " ": mn = mn + 1: m(mn).x = i: m(mn).y = ii: m(mn).id = 0: m(mn).alive = 1
         IF VAL(map(i, ii)) > 0 THEN
         mn = mn + 1: m(mn).id = VAL(map(i, ii))
         m(mn).x = i: m(mn).y = ii: m(mn).alive = 1
         map(i, ii) = " "
         END IF

            IF map(i, ii) = "y" THEN map(i, ii) = " ": keys(0).y = i: keys(1).y = ii
            IF map(i, ii) = "r" THEN map(i, ii) = " ": keys(0).r = i: keys(1).r = ii
            IF map(i, ii) = "b" THEN map(i, ii) = " ": keys(0).b = i: keys(1).b = ii

            IF map(i, ii) = "W" THEN PUT (i * 10 - 10, ii * 10 - 10), wall
            IF map(i, ii) = " " THEN PUT (i * 10 - 10, ii * 10 - 10), grnd
            IF map(i, ii) = "F" THEN PUT (i * 10 - 10, ii * 10 - 10), door
            IF map(i, ii) = "R" THEN PUT (i * 10 - 10, ii * 10 - 10), rl
            IF map(i, ii) = "Y" THEN PUT (i * 10 - 10, ii * 10 - 10), yl
            IF map(i, ii) = "B" THEN PUT (i * 10 - 10, ii * 10 - 10), bl
            'IF map(i, ii) = "r" THEN PUT (i * 10 - 10, ii * 10 - 10), rk
            'IF map(i, ii) = "b" THEN PUT (i * 10 - 10, ii * 10 - 10), bk
            'IF map(i, ii) = "y" THEN PUT (i * 10 - 10, ii * 10 - 10), yk

   NEXT i, ii
CLOSE #1

PCOPY 1, 2
PCOPY 2, 0

'NumLock off
DEF SEG = 0
p = PEEK(&H417)
POKE &H417, p AND (NOT 32)
DEF SEG

PlayAdlib "{INIT}", 0, Piano()
PlayAdlib "MNT1", 2, Piano()


RANDOMIZE TIMER
DO
  FOR t = 1 TO 10000: NEXT t
  'H = H + 1: IF H = 10 THEN READ der$: PlayAdlib der$, 2, Piano(): H = 0
  MoveM
  MoveFire
  GetKey
  Aply
  DrawAll
LOOP





'                       **********Graphics************
'
'Red lock
DATA &HA,&HA,&H0,&H0,&H80FF
DATA &H80FF,&H0,&H0,&H80E1,&H80
DATA &H0,&H0,&H80C0,&H80,&H0
DATA &H0,&H80C0,&H80,&H0,&H0
DATA &H80E1,&H80,&H0,&H0,&H80F3
DATA &H80,&H0,&H0,&H80E1,&H80
DATA &H0,&H0,&H80C0,&H80,&H0
DATA &H0,&H80FF,&H80,&H0,&H0
DATA &H0,&H0,&H0,&H0,&H0
DATA &H0,&H0,&H0,&H0,&H0
'Yellow lock
DATA &HA,&HA,&H80FF,&HC0FF,&HC0FF,&H80FF,&H80,&HC0E1,&HC0E1,&H80E1
DATA &H80,&HC0C0,&HC0C0,&H80C0,&H80,&HC0C0,&HC0C0,&H80C0,&H80,&HC0E1
DATA &HC0E1,&H80E1,&H80,&HC0F3,&HC0F3,&H80F3,&H80,&HC0E1,&HC0E1,&H80E1
DATA &H80,&HC0C0,&HC0C0,&H80C0,&H80,&HC0FF,&HC0FF,&H80FF,&H0,&HC0FF
DATA &HC0FF,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'Blue lock
DATA &HA,&HA,&H80FF,&H0,&H0,&H80FF,&H80E1,&H0,&H0,&H80
DATA &H80C0,&H0,&H0,&H80,&H80C0,&H0,&H0,&H80,&H80E1,&H0
DATA &H0,&H80,&H80F3,&H0,&H0,&H80,&H80E1,&H0,&H0,&H80
DATA &H80C0,&H0,&H0,&H80,&H80FF,&H0,&H0,&H80,&H0,&H0
DATA &H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'Door
DATA &HA,&HA,&HC0FF,&HC0FF,&H0,&HC0FF,&HC0E1,&HC0FD,&H1E,&HC0E1
DATA &HC0C0,&HC0F7,&H3F,&HC0C0,&H4080,&H40DD,&H807F,&H4080,&H4080,&HC0F7
DATA &H807F,&H4080,&H4080,&HC0DD,&H807F,&H4080,&H4080,&H40F7,&H807F,&H4080
DATA &H4080,&HC0DD,&H807F,&H4080,&H4080,&H40F7,&H807F,&H4080,&H0,&HC0FF
DATA &H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'Man
DATA &HA,&HA,&HC0E1,&HC0E1,&HC0E1,&H0,&HC0E1,&HC0E1,&HC0ED,&HC
DATA &HC0F3,&HC0F3,&HC0FF,&HC,&HC0FF,&HC0E1,&HC0E1,&H1E,&HC0FF,&HC0D2
DATA &HC0D2,&H2D,&HC0FF,&HC0D2,&HC0D2,&H2D,&HC0FF,&HC0F3,&HC0F3,&HC
DATA &HC0F3,&HC0FF,&HC0FF,&HC,&HC0ED,&HC0FF,&HC0FF,&H12,&HC0DE,&HC0FF
DATA &HC0FF,&H21,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'Wall
'DATA &HA,&HA,&H0,&H80FF,&H80FF,&H80FF,&H0,&H92,&H80FF,&H80
'DATA &H0,&H80FF,&H80FF,&H80,&H0,&H49,&H80FF,&H80,&H0,&H80FF
'DATA &H80FF,&H80,&H0,&H92,&H80FF,&H80,&H0,&H80FF,&H80FF,&H80
'DATA &H0,&H49,&H80FF,&H80,&H0,&H80FF,&H80FF,&H80,&H0,&H0
'DATA &H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'Blue key
DATA &HA,&HA,&H80FF,&H80FF,&H80FF,&H80FF,&H80FF,&H80E1,&H80E1,&H80
DATA &H80FF,&H80ED,&H80ED,&H80,&H80FF,&H80E1,&H80E1,&H80,&H80FF,&H80FB
DATA &H80FB,&H80,&H80FF,&H80FB,&H80FB,&H80,&H80FF,&H80FB,&H80FB,&H80
DATA &H80FF,&H80F3,&H80F3,&H80,&H80FF,&H80E3,&H80E3,&H80,&H0,&H0
DATA &H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'Red key
DATA &HA,&HA,&H80FF,&H80FF,&H80FF,&H80FF,&H80E1,&H80E1,&H80FF,&H80
DATA &H80ED,&H80ED,&H80FF,&H80,&H80E1,&H80E1,&H80FF,&H80,&H80FB,&H80FB
DATA &H80FF,&H80,&H80FB,&H80FB,&H80FF,&H80,&H80FB,&H80FB,&H80FF,&H80
DATA &H80F3,&H80F3,&H80FF,&H80,&H80E3,&H80E3,&H80FF,&H80,&H0,&H0
DATA &H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'Yellow key
DATA &HA,&HA,&H80FF,&H80FF,&H80FF,&H80FF,&H80E1,&H80FF,&H80FF,&H9E
DATA &H80ED,&H80FF,&H80FF,&H92,&H80E1,&H80FF,&H80FF,&H9E,&H80FB,&H80FF
DATA &H80FF,&H84,&H80FB,&H80FF,&H80FF,&H84,&H80FB,&H80FF,&H80FF,&H84
DATA &H80F3,&H80FF,&H80FF,&H8C,&H80E3,&H80FF,&H80FF,&H9C,&H0,&H0
DATA &H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'MONSTER 0
DATA &HA,&HA,&HC0FF,&HC0FF,&HC0FF,&H0,&HC0C1,&HC0C1,&HC0C1,&H0
DATA &HC0D5,&HC0D5,&HC0D5,&H14,&HC0C1,&HC0C9,&HC0C1,&H0,&HC0C1,&HC0DD
DATA &HC0C1,&H0,&HC0C0,&HC0DE,&HC0C0,&H0,&HC080,&HC0BE,&HC080,&H14
DATA &H4000,&H407F,&H4000,&H0,&H0,&H807F,&H0,&H0,&HC0AA,&HC0FF
DATA &HC0FF,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'MONSTER 1
DATA &HA,&HA,&HC0FF,&HC0FF,&HC0FF,&H0,&HC0F7,&HC0F7,&HC0FF,&H0
DATA &HC0F7,&HC0F7,&HC0FF,&H0,&HC0E1,&HC0E1,&HC0E1,&H0,&HC0C0,&HC0C0
DATA &HC0C0,&H0,&H4094,&H4094,&H4094,&H14,&H4080,&H4080,&H4080,&H0
DATA &H4080,&H4080,&H4080,&HC,&HC0C0,&HC0C0,&HC0C0,&H12,&HC0E1,&HC0E1
DATA &HC0E1,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'Fire Up
DATA &HA,&HA,&HC0FF,&HC0FF,&HC0FF,&H0,&HC0FF,&HC0E3,&HC0E3,&H0
DATA &HC0FF,&HC0C1,&HC0C1,&H8,&HC0FF,&HC0C9,&HC0C1,&H1C,&HC0FF,&HC0C9
DATA &HC0C1,&H1C,&HC0FF,&HC0E3,&HC0E3,&H8,&HC0FF,&HC0F7,&HC0F7,&H0
DATA &HC0FF,&HC0F7,&HC0F7,&H0,&HC0FF,&HC0FF,&HC0FF,&H0,&HC0FF,&HC0FF
DATA &HC0FF,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'Fire Right
DATA &HA,&HA,&HC0FF,&HC0FF,&HC0FF,&H0,&HC0FF,&HC0FF,&HC0FF,&H0
DATA &HC0FF,&HC0FF,&HC0FF,&H0,&HC0FF,&HC0F1,&HC0F1,&H0,&HC0FF,&HC0E0
DATA &HC0E0,&HC,&HC0FF,&HC08C,&HC080,&H1E,&HC0FF,&HC0E0,&HC0E0,&HC
DATA &HC0FF,&HC0F1,&HC0F1,&H0,&HC0FF,&HC0FF,&HC0FF,&H0,&HC0FF,&HC0FF
DATA &HC0FF,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'Fire Down
DATA &HA,&HA,&HC0FF,&HC0FF,&HC0FF,&H0,&HC0FF,&HC0F7,&HC0F7,&H0
DATA &HC0FF,&HC0F7,&HC0F7,&H0,&HC0FF,&HC0E3,&HC0E3,&H8,&HC0FF,&HC0C9
DATA &HC0C1,&H1C,&HC0FF,&HC0C9,&HC0C1,&H1C,&HC0FF,&HC0C1,&HC0C1,&H8
DATA &HC0FF,&HC0E3,&HC0E3,&H0,&HC0FF,&HC0FF,&HC0FF,&H0,&HC0FF,&HC0FF
DATA &HC0FF,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0
'Fire Left
DATA &HA,&HA,&HC0FF,&HC0FF,&HC0FF,&H0,&HC0FF,&HC0FF,&HC0FF,&H0
DATA &HC0FF,&HC0FF,&HC0FF,&H0,&HC0FF,&HC0E3,&HC0E3,&H0,&HC0FF,&HC0C1
DATA &HC0C1,&HC,&HC0FF,&H40CC,&H40C0,&H1E,&HC0FF,&HC0C1,&HC0C1,&HC
DATA &HC0FF,&HC0E3,&HC0E3,&H0,&HC0FF,&HC0FF,&HC0FF,&H0,&HC0FF,&HC0FF
DATA &HC0FF,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0,&H0

SUB Aply

IF you.x = keys(0).y AND you.y = keys(1).y THEN keys(0).y = -1: PlayFX "GetKey": you.ykey = 1
IF you.x = keys(0).r AND you.y = keys(1).r THEN keys(0).r = -1: PlayFX "GetKey": you.rkey = 1
IF you.x = keys(0).b AND you.y = keys(1).b THEN keys(0).b = -1: PlayFX "GetKey": you.bkey = 1

IF you.heal < 0 THEN PlayFX "DEAD": END

'IF INSTR("yrb", map(you.x, you.y)) THEN
'PlayFX "GETKEY"
'IF map(you.x, you.y) = "y" THEN you.ykey = 1
'IF map(you.x, you.y) = "r" THEN you.rkey = 1
'IF map(you.x, you.y) = "b" THEN you.bkey = 1
'map(you.x, you.y) = " "
'END IF


IF MoveTime = 0 THEN
'Checa se o monstro encostou em voce
DO
i = i + 1: IF i > monsters THEN EXIT DO
IF m(i).alive = 1 THEN
IF m(i).x = you.x AND m(i).y = you.y THEN
  Hitted = 1
  you.heal = you.heal - 1
  m(i).dir = INT(RND * 4) + 1
  IF m(i).dir = 0 THEN m(i).dir = 4
  IF m(i).dir = -1 THEN m(i).dir = 3
END IF
END IF
LOOP
END IF

END SUB

FUNCTION Dire (direcao$)

IF direcao$ = "U" THEN Dire = 1
IF direcao$ = "R" THEN Dire = 2
IF direcao$ = "D" THEN Dire = 3
IF direcao$ = "L" THEN Dire = 4

END FUNCTION

SUB DrawAll

PCOPY 2, 1

'Keys
IF keys(0).y > 0 AND keys(1).y > 0 THEN PUT (keys(0).y * 10 - 10, keys(1).y * 10 - 10), yk, PSET
IF keys(0).r > 0 AND keys(1).r > 0 THEN PUT (keys(0).r * 10 - 10, keys(1).r * 10 - 10), rk, PSET
IF keys(0).b > 0 AND keys(1).b > 0 THEN PUT (keys(0).b * 10 - 10, keys(1).b * 10 - 10), bk, PSET

'The Monsters ;-(
FOR i = 1 TO monsters
IF m(i).alive = 1 THEN
  PUT (m(i).x * 10 - 10, m(i).y * 10 - 10), Monster(0, m(i).id), PSET
END IF
NEXT i

'Fire  !
FOR i = 1 TO 4
IF f(i).ready = 0 THEN PUT (f(i).x * 10 - 10, f(i).y * 10 - 10), fire(0, f(i).dir), PSET
NEXT i


'You :-D
PUT (you.x * 10 - 10, you.y * 10 - 10), man, PSET

LINE (0, 0)-(18, 9), 0, BF
Font LTRIM$(STR$(you.heal)), 0, 1, 8
Font LTRIM$(STR$(you.heal)), 1, 2, 14

IF mk = 1 THEN LOCATE 1, 1: PRINT "MK!": mk = 0: END

PCOPY 1, 0

END SUB

SUB DrawMap (xmin, ymin, xmax, ymax)
      FOR i = xmin TO xmax
      FOR ii = ymin TO ymax
      IF map(i, ii) = "S" THEN map(i, ii) = " ": you.x = i: you.y = ii
      IF map(i, ii) = "0" THEN map(i, ii) = " ": mn = mn + 1: m(mn).x = i: m(mn).y = ii: m(mn).id = 0: m(mn).alive = 1
         IF VAL(map(i, ii)) > 0 THEN
         mn = mn + 1: m(mn).id = VAL(map(i, ii))
         m(mn).x = i: m(mn).y = ii: m(mn).alive = 1
         map(i, ii) = " "
         END IF

            IF map(i, ii) = "y" THEN map(i, ii) = " ": keys(0).y = i: keys(1).y = ii
            IF map(i, ii) = "r" THEN map(i, ii) = " ": keys(0).r = i: keys(1).r = ii
            IF map(i, ii) = "b" THEN map(i, ii) = " ": keys(0).b = i: keys(1).b = ii

            IF map(i, ii) = "W" THEN PUT (i * 10 - 10, ii * 10 - 10), wall, PSET
            IF map(i, ii) = " " THEN PUT (i * 10 - 10, ii * 10 - 10), grnd, PSET
            IF map(i, ii) = "F" THEN PUT (i * 10 - 10, ii * 10 - 10), door, PSET
            IF map(i, ii) = "R" THEN PUT (i * 10 - 10, ii * 10 - 10), rl, PSET
            IF map(i, ii) = "Y" THEN PUT (i * 10 - 10, ii * 10 - 10), yl, PSET
            IF map(i, ii) = "B" THEN PUT (i * 10 - 10, ii * 10 - 10), bl, PSET
            'IF map(i, ii) = "r" THEN PUT (i * 10 - 10, ii * 10 - 10), rk ,pset
            'IF map(i, ii) = "b" THEN PUT (i * 10 - 10, ii * 10 - 10), bk ,pset
            'IF map(i, ii) = "y" THEN PUT (i * 10 - 10, ii * 10 - 10), yk ,pset

NEXT ii, i
END SUB

SUB Font (Text$, xPos%, yPos%, TextColor%)
DEFINT A-Z

  IF xPos = -1 THEN xPos = 320 - (LEN(Text$) * 8) \ 2
  xPos = ABS(xPos)

DEF SEG = &HFFA6
FOR le = 1 TO LEN(Text$)
                    add = (8 * ASC((MID$(Text$, le)))) + 14
  FOR yp = 0 TO 7
                    m = PEEK(add + yp) * 128
                    LINE (xPos + xp, yPos + yp)-(xPos + xp + 8, yPos + yp), TextColor, , m
  NEXT yp
                    xp = xp + 8
NEXT le

DEF SEG

END SUB

SUB GetKey

FOR i = 1 TO 4
fi = 0
IF f(i).ready = 1 THEN fi = i: EXIT FOR
NEXT i

k$ = INKEY$

SELECT CASE k$
'Move
CASE CHR$(0) + "H"
   IF you.y > 1 THEN IF map(you.x, you.y - 1) <> "W" THEN you.y = you.y - 1
CASE CHR$(0) + "P"
   IF you.y < 20 THEN IF map(you.x, you.y + 1) <> "W" THEN you.y = you.y + 1
CASE CHR$(0) + "K"
   IF you.x > 1 THEN IF map(you.x - 1, you.y) <> "W" THEN you.x = you.x - 1
CASE CHR$(0) + "M"
   IF you.x < 32 THEN IF map(you.x + 1, you.y) <> "W" THEN you.x = you.x + 1

   SELECT CASE map(you.x, you.y)
   CASE "y", "r", "b"
    PlayFX "GETKEY"
   END SELECT

  
'Fire
CASE "8"
  IF fi <> 0 THEN f(fi).ready = 0: f(fi).x = you.x: f(fi).y = you.y: f(fi).dir = 1: PlayFX "Fire"
CASE "6"
  IF fi <> 0 THEN f(fi).ready = 0: f(fi).x = you.x: f(fi).y = you.y: f(fi).dir = 2: PlayFX "Fire"
CASE "2"
  IF fi <> 0 THEN f(fi).ready = 0: f(fi).x = you.x: f(fi).y = you.y: f(fi).dir = 3: PlayFX "Fire"
CASE "4"
  IF fi <> 0 THEN f(fi).ready = 0: f(fi).x = you.x: f(fi).y = you.y: f(fi).dir = 4: PlayFX "Fire"
END SELECT


END SUB

SUB KillMonster (number)

IF m(number).id = 1 THEN
map(m(number).x + 1, m(number).y) = " "
map(m(number).x + 1, m(number).y + 1) = " "
map(m(number).x + 1, m(number).y - 1) = " "
map(m(number).x - 1, m(number).y) = " "
map(m(number).x - 1, m(number).y + 1) = " "
map(m(number).x - 1, m(number).y - 1) = " "
map(m(number).x, m(number).y + 1) = " "
map(m(number).x, m(number).y - 1) = " "
PlayFX "BooM"
SCREEN 7, 0, 2, 1
DrawMap m(number).x - 1, m(number).y - 1, m(number).x + 1, m(number).y + 1
'PCOPY 3, 2
SCREEN 7, 0, 1, 0
END IF

m(number).x = -1: m(number).y = -1: m(number).alive = 0


temp = 1

END SUB

SUB LoadGFX
  
   LINE (1, 1)-(10, 10), 7, BF
   GET (1, 1)-(10, 10), grnd
                                    LINE (1, 1)-(10, 10), 0, BF
   FOR i% = 0 TO 49
   READ rl(i%)
   NEXT i%
  
   FOR i% = 0 TO 49
   READ yl(i%)
   NEXT i%

   FOR i% = 0 TO 49
   READ bl(i%)
   NEXT i%

   FOR i% = 0 TO 49
   READ door(i%)
   NEXT i%

   FOR i% = 0 TO 49
   READ man(i%)
   NEXT i%

   'FOR i% = 0 TO 49
   'READ wall(i%)
   'NEXT i%
  
   FOR i% = 0 TO 49
   READ bk(i%)
   NEXT i%

   FOR i% = 0 TO 49
   READ rk(i%)
   NEXT i%

   FOR i% = 0 TO 49
   READ yk(i%)
   NEXT i%

   FOR j% = 0 TO 1
   FOR i% = 0 TO 49
   READ Monster(i%, j%)
   NEXT i%
   NEXT j%

   FOR j% = 1 TO 4
   FOR i% = 0 TO 49
   READ fire(i%, j%)
   NEXT i%
   NEXT j%

END SUB

SUB MilliDelay (msecs) STATIC

DEFINT A-Z

    IF sysfact& THEN                             'calc- system speed yet?
        IF msecs THEN                            'have to want a delay
            count& = (sysfact& * msecs) \ -54    'calc- # of loops needed
            DO
                count& = count& + 1              'negative - add to get to 0
                IF count& = z THEN EXIT DO       'when its 0 we're done
            LOOP UNTIL t2 = PEEK(&H6C)           'make it the same as below
        END IF
    ELSE                                         'calc- system speed
        DEF SEG = &H40                           'point to low memory
        t1 = PEEK(&H6C)                          'get tick count
        DO
            t2 = PEEK(&H6C)                      'get tick count
        LOOP UNTIL t2 <> t1                      'wait 'til its a new tick
        DO
            sysfact& = sysfact& + 1              'count number of loops
            IF sysfact& = z THEN EXIT DO         'make it the same as above
        LOOP UNTIL t2 <> PEEK(&H6C)              'wait 'til its a new tick
        t2 = 256                                 'prevent the above UNTIL
    END IF

END SUB

SUB MoveFire
STATIC ChangeTime

ChangeTime = ChangeTime + 1

IF ChangeTime < 10 THEN EXIT SUB
ChangeTime = 0



FOR i = 1 TO 4

IF f(i).ready = 0 THEN

SELECT CASE f(i).dir
  CASE 1
    IF map(f(i).x, f(i).y - 1) <> "W" THEN f(i).y = f(i).y - 1 ELSE f(i).ready = 1
    FOR j = 1 TO monsters
    IF f(i).y = m(j).y AND f(i).x = m(j).x THEN KillMonster j: f(i).ready = 1
    'IF map(f(i).x, f(i).y) = "W" THEN f(i).ready = 1
    NEXT j
  CASE 2
    IF map(f(i).x + 1, f(i).y) <> "W" THEN f(i).x = f(i).x + 1 ELSE f(i).ready = 1
    FOR j = 1 TO monsters
    IF f(i).y = m(j).y AND f(i).x = m(j).x THEN KillMonster j: f(i).ready = 1
    'IF map(f(i).x, f(i).y) = "W" THEN f(i).ready = 1
    NEXT j
  CASE 3
    IF map(f(i).x, f(i).y + 1) <> "W" THEN f(i).y = f(i).y + 1 ELSE f(i).ready = 1
    FOR j = 1 TO monsters
    IF f(i).y = m(j).y AND f(i).x = m(j).x THEN KillMonster j: f(i).ready = 1
    'IF map(f(i).x, f(i).y) = "W" THEN f(i).ready = 1
    NEXT j
  CASE 4
    IF map(f(i).x - 1, f(i).y) <> "W" THEN f(i).x = f(i).x - 1 ELSE f(i).ready = 1
    FOR j = 1 TO monsters
    IF f(i).y = m(j).y AND f(i).x = m(j).x THEN KillMonster j: f(i).ready = 1
    'IF map(f(i).x, f(i).y) = "W" THEN f(i).ready = 1
    NEXT j



END SELECT


END IF
    

NEXT i


END SUB

SUB MoveM
STATIC MoveTime
MoveTime = MoveTime + 1

IF MoveTime < 10 THEN EXIT SUB
MoveTime = 0

FOR i = 1 TO monsters

IF m(i).move = 0 THEN a = 1
IF m(i).move = 1 THEN a = -1


IF m(i).alive = 1 THEN
  SELECT CASE m(i).dir
    CASE 1
          IF map(m(i).x, m(i).y - 1) <> "W" THEN m(i).y = m(i).y - 1
        IF m(i).move <= 1 THEN
          IF map(m(i).x, m(i).y - 1) = "W" THEN m(i).dir = m(i).dir + a
          IF m(i).dir = 5 THEN m(i).dir = 1
          IF m(i).dir = 0 THEN m(i).dir = 4
        END IF
        IF m(i).move = 2 THEN
          IF map(m(i).x, m(i).y - 1) = "W" THEN m(i).dir = m(i).dir + 2
          DO
          IF m(i).dir < 1 THEN m(i).dir = m(i).dir + 2
          IF m(i).dir > 4 THEN m(i).dir = m(i).dir - 2
          LOOP UNTIL m(i).dir > 0 AND m(i).dir < 5
        END IF
    CASE 2
          IF map(m(i).x + 1, m(i).y) <> "W" THEN m(i).x = m(i).x + 1
        IF m(i).move <= 1 THEN
          IF map(m(i).x + 1, m(i).y) = "W" THEN m(i).dir = m(i).dir + a
          IF m(i).dir = 5 THEN m(i).dir = 1
          IF m(i).dir = 0 THEN m(i).dir = 4
        END IF
        IF m(i).move = 2 THEN
          IF map(m(i).x + 1, m(i).y) = "W" THEN m(i).dir = m(i).dir - 2
          DO
          IF m(i).dir < 1 THEN m(i).dir = m(i).dir + 4
          IF m(i).dir > 4 THEN m(i).dir = m(i).dir - 4
          LOOP UNTIL m(i).dir > 0 AND m(i).dir < 5
        END IF

    CASE 3
          IF map(m(i).x, m(i).y + 1) <> "W" THEN m(i).y = m(i).y + 1
        IF m(i).move <= 1 THEN
          IF map(m(i).x, m(i).y + 1) = "W" THEN m(i).dir = m(i).dir + a
          IF m(i).dir = 5 THEN m(i).dir = 1
          IF m(i).dir = 0 THEN m(i).dir = 4
        END IF
        IF m(i).move = 2 THEN
          IF map(m(i).x, m(i).y + 1) = "W" THEN m(i).dir = m(i).dir - 2
          DO
          IF m(i).dir = 5 THEN m(i).dir = 1
          IF m(i).dir = 0 THEN m(i).dir = 4
          LOOP UNTIL m(i).dir > 0 AND m(i).dir < 5
        END IF

    CASE 4
          IF map(m(i).x - 1, m(i).y) <> "W" THEN m(i).x = m(i).x - 1
        IF m(i).move <= 1 THEN
          IF map(m(i).x - 1, m(i).y) = "W" THEN m(i).dir = m(i).dir + a
          IF m(i).dir = 5 THEN m(i).dir = 1
          IF m(i).dir = 0 THEN m(i).dir = 4
        END IF
        IF m(i).move = 2 THEN
          IF map(m(i).x - 1, m(i).y) = "W" THEN m(i).dir = m(i).dir + 2
          DO
          IF m(i).dir < 1 THEN m(i).dir = m(i).dir + 4
          IF m(i).dir > 4 THEN m(i).dir = m(i).dir - 4
          LOOP UNTIL m(i).dir > 0 AND m(i).dir < 5
        END IF

  END SELECT

END IF






NEXT i








  


END SUB

SUB PlayAdlib (comand$, chann%, ins%())
STATIC tempo, length, music, octave
IF comand$ = "{INIT}" THEN
 tempo = 120
 length = 4
 music = 7 / 8
 octave = 4
 FOR i% = 0 TO 224: WriteReg i%, 0: NEXT i%
 EXIT SUB
END IF
comand$ = UCASE$(comand$)

WriteReg &HB0 + chann%, 0

WriteReg &H20 + chann%, ins%(1)
WriteReg &H23 + chann%, ins%(2)
WriteReg &H40 + chann%, ins%(3)
WriteReg &H43 + chann%, ins%(4)
WriteReg &H60 + chann%, ins%(5)
WriteReg &H63 + chann%, ins%(6)
WriteReg &H80 + chann%, ins%(7)
WriteReg &H83 + chann%, ins%(8)

c% = 1
max% = LEN(comand$)
WHILE c% <= max%
 x$ = MID$(comand$, c%, 1): c% = c% + 1
 IF INSTR("ABCDEFG", x$) <> 0 AND (c% <> max% AND INSTR("+#-", MID$(comand$, c%, 1))) THEN
  x$ = x$ + MID$(comand$, c%, 1): c% = c% + 1
  IF RIGHT$(x$, 1) = "+" THEN x$ = LEFT$(x$, 1) + "#"
  IF x$ = "D-" THEN x$ = "C#"
  IF x$ = "E-" THEN x$ = "D#"
  IF x$ = "G-" THEN x$ = "F#"
  IF x$ = "A-" THEN x$ = "G#"
  IF x$ = "B-" THEN x$ = "A#"
 ELSEIF x$ = "O" THEN
  adj% = VAL(MID$(comand$, c%, 1)): c% = c% + 1
  IF adj% >= 0 AND adj% <= 6 THEN octave = adj%
 ELSEIF x$ = "<" AND octave > 0 THEN
  octave = octave - 1
 ELSEIF x$ = ">" AND octave < 6 THEN
  octave = octave + 1
 ELSEIF x$ = "L" THEN
  num$ = ""
  WHILE INSTR("0123456789", MID$(comand$, c%, 1))
   num$ = num$ + MID$(comand$, c%, 1): c% = c% + 1
  WEND
  IF VAL(LTRIM$(num$)) >= 1 AND VAL(LTRIM$(num$)) <= 64 THEN length = VAL(LTRIM$(num$))
 ELSEIF x$ = "P" THEN
  dotfac = 1
  num$ = ""
  num$ = MID$(comand$, c%, 1): c% = c% + 1
  WHILE MID$(comand$, c%, 1) = "."
   dotfac = dotfac * 1.5: c% = c% + 1
  WEND
  IF VAL(num$) >= 1 AND VAL(num$) <= 64 THEN
   start! = TIMER
   ender! = start! + (((1 / VAL(num$)) * dotfac) * ((tempo / 120) * 2) * music) / 2'/2 weg
   EXIT SUB
   END IF
 ELSEIF x$ = "M" THEN
  next$ = MID$(comand$, c%, 1): c% = c% + 1
  x$ = x$ + next$
  IF x$ = "MN" THEN music = 7 / 8
  IF x$ = "MS" THEN music = 3 / 4
  IF x$ = "ML" THEN music = 1
 END IF
 IF INSTR("ABCDEFG", LEFT$(x$, 1)) THEN
  dotfac = 1
  WHILE MID$(comand$, c%, 1) = "."
   dotfac = dotfac * 1.5: c% = c% + 1
  WEND
  SELECT CASE x$
  CASE "C#"
   WriteReg &HA0 + chann%, &H6B
   WriteReg &HB0 + chann%, &H21 + 4 * octave
  CASE "D"
   WriteReg &HA0 + chann%, &H81
   WriteReg &HB0 + chann%, &H21 + 4 * octave
  CASE "D#"
   WriteReg &HA0 + chann%, &H98
   WriteReg &HB0 + chann%, &H21 + 4 * octave
  CASE "E"
   WriteReg &HA0 + chann%, &HB0
   WriteReg &HB0 + chann%, &H21 + 4 * octave
  CASE "F"
   WriteReg &HA0 + chann%, &HCA
   WriteReg &HB0 + chann%, &H21 + 4 * octave
  CASE "F#"
   WriteReg &HA0 + chann%, &HE5
   WriteReg &HB0 + chann%, &H21 + 4 * octave
  CASE "G"
   WriteReg &HA0 + chann%, &H2
   WriteReg &HB0 + chann%, &H22 + 4 * octave
  CASE "G#"
   WriteReg &HA0 + chann%, &H20
   WriteReg &HB0 + chann%, &H22 + 4 * octave
  CASE "A"
   WriteReg &HA0 + chann%, &H41
   WriteReg &HB0 + chann%, &H22 + 4 * octave
  CASE "A#"
   WriteReg &HA0 + chann%, &H63
   WriteReg &HB0 + chann%, &H22 + 4 * octave
  CASE "B"
   WriteReg &HA0 + chann%, &H87
   WriteReg &HB0 + chann%, &H22 + 4 * octave
  CASE "C"
   WriteReg &HA0 + chann%, &HAE
   WriteReg &HB0 + chann%, &H22 + 4 * (octave - 1)
  END SELECT
  start! = TIMER
  ender! = start! + ((1 / length) * dotfac) * ((tempo / 120) * 2) * music / 2'/2 weg
  EXIT SUB
  END IF
WEND

END SUB

SUB PlayFX (fxname$)
fxname$ = UCASE$(fxname$)

chan$ = "&hB0&h20&h23&h40&h43&h60&h63&h80&h83&hA0&HBD&HC0&HE0&HE3&hB0"

SELECT CASE fxname$
CASE "FIRE"
sfx$ = "&H00&H00&H00&H00&H03&H56&H65&HAB&HA1&H25&HC0&H00&H00&H00&H27&H0"
CASE "GETKEY"
'sfx$ = "&H00&H06&H00&H03&H03&HEC&HE2&H28&H28&H00&HC0&H01&H00&H00&H39&H0"
sfx$ = "&H00&H00&H00&H00&H03&H4D&HAC&H49&H18&H25&HC0&H02&H01&H01&H3B&H0"
CASE "BOOM"
chan$ = "&hB1&h21&h24&h41&h44&h61&h64&h81&h84&hA1&HBD&HC1&HE1&HE4&hB1"
sfx$ = "&H00&H80&H00&H00&H00&HF0&HB9&HA2&H04&H89&HC0&H0E&H00&H00&H20&H1"
CASE "DEAD"
chan$ = "&hB3&h28&h2B&h48&h4B&h68&h6B&h88&h8B&hA3&HBD&HC3&HE8&HEB&hB3"
sfx$ = "&H00&H00&H00&H03&H00&H42&H81&HA9&H23&H06&HC0&H06&H01&H01&H2A&H3"
END SELECT



FOR in = 1 TO 60 STEP 4
  reg$ = MID$(chan$, in, 4): reg% = VAL(reg$)
  dat$ = MID$(sfx$, in, 4): dat% = VAL(dat$)
  OUT &H388, reg%: ' FOR d% = 1 TO 6: b% = INP(&H388): NEXT
  OUT &H389, dat%: ' FOR d% = 1 TO 35: b% = INP(&H388): NEXT
NEXT


END SUB

FUNCTION Ret (atual, limite)

DO
atual = atual - limite
LOOP UNTIL atual <= limite
Ret = atual

END FUNCTION

SUB WriteReg (reg%, value%)

SHARED RegAdd%, DataAdd%

OUT RegAdd%, reg%
OUT DataAdd%, value%

END SUB

